﻿using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Syncfusion.UI.Xaml.Grid.Helpers;

namespace MasterDetails_SfDataGrid
{
   public class Command
    {
        static Command()
        {
            CommandManager.RegisterClassCommandBinding(typeof(SfDataGrid), new CommandBinding(AddColumn, OnAddColumn));
            CommandManager.RegisterClassCommandBinding(typeof(SfDataGrid), new CommandBinding(GetRowValue, OnGetRowValue));
        }

        public static RoutedCommand AddColumn = new RoutedCommand("AddColumn", typeof(SfDataGrid));

        private static void OnAddColumn(object sender, ExecutedRoutedEventArgs args)
        {
            var sfDataGrid = sender as SfDataGrid;  
            //columns added dynamically for DetailsViewDataGrid
            (sfDataGrid.DetailsViewDefinition[0] as GridViewDefinition).DataGrid.Columns.Add(new GridTextColumn() { MappingName = "ProductName", HeaderText = "Product Name" });         
             sfDataGrid.GetVisualContainer().InvalidateMeasure();
        }

        public static RoutedCommand GetRowValue = new RoutedCommand("GetRowValue", typeof(SfDataGrid));

        private static void OnGetRowValue(object sender, ExecutedRoutedEventArgs args)
        {
            var sfDataGrid = sender as SfDataGrid;
            //You can get corresponding DetailsViewDataGrid ,for accessing records count of Details View 
            var detailsViewDataGrid = sfDataGrid.GetDetailsViewGrid(sfDataGrid.ResolveToRecordIndex(sfDataGrid.SelectionController.CurrentCellManager.CurrentCell.RowIndex), "ProductDetails");
            var records = detailsViewDataGrid.View.Records;
            List<object> columnvalue = new List<object>();
            var provider = detailsViewDataGrid.View.GetPropertyAccessProvider();
            for (int i = 0; i < detailsViewDataGrid.View.Records.Count; i++)
            {
                columnvalue.Add(provider.GetValue((records[i] as RecordEntry).Data, "ProductId"));
            }
        } 
    }
}
