﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MasterDetails_SfDataGrid
{
    public class OrderInfo : INotifyPropertyChanged
   {
       int orderID;
       string customerId;
       string country;
       string customerName;
       string shippingCity;
       ObservableCollection<ProductInfo> productDetails;

       public int OrderID
       {
           get 
           { 
               return orderID; 
           }
           set 
           { 
               orderID = value; 
               RaisePropertyChanged("OrderID"); 
           }
       }

       public string CustomerID
       {
           get 
           { 
               return customerId; 
           }
           set 
           {
               customerId = value; 
               RaisePropertyChanged("CustomerID"); 
           }
       }

       public string CustomerName
       {
           get 
           {
               return customerName; 
           }
           set 
           { 
               customerName = value; 
               RaisePropertyChanged("CustomerName"); 
           }
       }



       public string Country
       {
           get 
           { 
               return country; 
           }
           set 
           { 
               country = value; 
               RaisePropertyChanged("Country"); 
           }
       }



       public string ShipCity
       {
           get 
           { 
               return shippingCity; 
           }
           set 
           { 
               shippingCity = value; 
               RaisePropertyChanged("ShipCity"); 
           }
       }



       public ObservableCollection<ProductInfo> ProductDetails
       {
           get 
           { 
               return productDetails; 
           }
           set 
           { 
               productDetails = value; 
               RaisePropertyChanged("ProductDetails"); 
           }

       }

       public OrderInfo(int orderId, string customerName, string country, string customerId, string shipCity, ObservableCollection<ProductInfo> productdetails)
       {
           this.OrderID = orderId;
           this.CustomerName = customerName;
           this.Country = country;
           this.CustomerID = customerId;
           this.ShipCity = shipCity;
           this.ProductDetails = productdetails;
       }

       public event PropertyChangedEventHandler PropertyChanged;
       public void RaisePropertyChanged(string propName)
       {
           if (this.PropertyChanged != null)
               this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
       }
   }
}
