﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MasterDetails_SfDataGrid
{
    public class OrderInfoRepositiory : INotifyPropertyChanged
    {

       public List<long> PhoneNumberCollection
       {
           get;
           set;
       }

       public List<string> NameCollection
       {
           get;
           set;
       }
        ObservableCollection<OrderInfo> orderCollection;
        public ObservableCollection<OrderInfo> OrderInfoCollection
        {
            get { return orderCollection; }
            set { orderCollection = value; RaisePropertyChanged("OrderInfoCollection"); }
        }

        public OrderInfoRepositiory()
        {
            orderCollection = new ObservableCollection<OrderInfo>();
            this.GenerateProducts();
            OrderInfoCollection = GenerateOrders();
        }

        public ObservableCollection<OrderInfo> GenerateOrders()
        {

            PhoneNumberCollection = new List<long>();
            PhoneNumberCollection.Add(9231345123);
            PhoneNumberCollection.Add(9453845546);
            PhoneNumberCollection.Add(8934343745);

            NameCollection = new List<string>();
            NameCollection.Add("Bike1");
            NameCollection.Add("Bike2");
            NameCollection.Add("Bike3");
            NameCollection.Add("Bike4");
            NameCollection.Add("Bike5");
            NameCollection.Add("Bike6");

            ObservableCollection<OrderInfo> orders = new ObservableCollection<OrderInfo>();          
            orders.Add(new OrderInfo(1001, "Maria Anders", "Germany", "ALFKI", "Berlin", getorder(1001)));
            orders.Add(new OrderInfo(1002, "Ana Trujilo", "Mexico", "ANATR", "México D.F.", getorder(1002)));
            orders.Add(new OrderInfo(1003, "Antonio Moreno", "Mexico", "ANTON", "México D.F.", getorder(1003)));
            orders.Add(new OrderInfo(1004, "Thomas Hardy", "UK", "AROUT", "London", getorder(1004)));
            orders.Add(new OrderInfo(1005, "Christina Berglund", "Sweden", "BERGS", "Luleå", getorder(1005)));
            orders.Add(new OrderInfo(1006, "Hanna Moos", "Germany", "BLAUS", "Mannheim", getorder(1006)));
            orders.Add(new OrderInfo(1007, "Frédérique Citeaux", "France", "BLONP", "Strasbourg", getorder(1007)));
            orders.Add(new OrderInfo(1008, "Martin Sommer", "Spain", "BOLID", "Madrid", getorder(1008)));
            orders.Add(new OrderInfo(1009, "Laurence Lebihan", "France", "BONAP", "Marseille", getorder(1009)));
            orders.Add(new OrderInfo(1010, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen", getorder(1010)));
            
            return orders;
        }

        ObservableCollection<ProductInfo> prod = new ObservableCollection<ProductInfo>();

        public void GenerateProducts()
        {
            prod.Add(new ProductInfo() { OrderID = 1001,ProductId=1, ProductNameList="Bike1", ProductName = "Bike1" ,PhoneNumber=92342323222});
            prod.Add(new ProductInfo() { OrderID = 1001, ProductId = 2, ProductNameList = "Bike2", ProductName = "Bike2", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1001, ProductId = 3,ProductNameList="Bike2", ProductName = "Bike2", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1002, ProductId = 4, ProductNameList = "Bike2", ProductName = "Bike2", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1002, ProductId = 5, ProductNameList = "Bike1", ProductName = "Bike1", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1002, ProductId = 6, ProductNameList = "Bike3", ProductName = "Bike3", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1003, ProductId = 7, ProductNameList = "Bike2", ProductName = "Bike2", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1003, ProductId = 8, ProductNameList = "Bike1", ProductName = "Bike1", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1004, ProductId = 9, ProductNameList = "Bike2", ProductName = "Bike2", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1004, ProductId = 10, ProductNameList = "Bike2", ProductName = "Bike2", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1005, ProductId = 11, ProductNameList = "Bike3", ProductName = "Bike3", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1005, ProductId = 12, ProductNameList = "Bike4", ProductName = "Bike4", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1005, ProductId = 13, ProductNameList = "Bike5", ProductName = "Bike5", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1006, ProductId = 14, ProductNameList = "Bike1", ProductName = "Bike1", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1006, ProductId = 15, ProductNameList = "Bike2", ProductName = "Bike2", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1007, ProductId = 16, ProductNameList = "Bike1", ProductName = "Bike1", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1008, ProductId = 17, ProductNameList = "Bike4", ProductName = "Bike4", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1008, ProductId = 18, ProductNameList = "Bike6", ProductName = "Bike6", PhoneNumber = 92342323222 });
            prod.Add(new ProductInfo() { OrderID = 1008, ProductId = 19, ProductNameList = "Bike7", ProductName = "Bike7", PhoneNumber = 92342323222 });
        }
        public ObservableCollection<ProductInfo> getorder(int i)
        {
            ObservableCollection<ProductInfo> product = new ObservableCollection<ProductInfo>();
            foreach (var or in prod)
                if (or.OrderID == i)
                    product.Add(or);
            return product;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
    }
}
